#include "config.h"
#include "assert_demos.h"
#include <nds32_intrinsic.h>
#include <stdio.h>

inline void GIE_ENABLE();
inline void GIE_DISABLE();
void initIntr();
void gen_swi();
int uart_puts(const char *s);

///*test error handle
void __attribute__ ((section (".new_nds32_init"))) new_error_exception_handler (unsigned int num)
{
	switch(num)
	 {
	    case 1:
	    	uart_puts("New TLB Fill Exception\n");
	    	break;
	    case 2:
	    	uart_puts("New PTE Not Present Exception\n");
	    	break;
	    case 3:
	    	uart_puts("New TLB Misc Exception\n");
	    	break;
	    case 4:
	    	uart_puts("New TLB VLPT Miss Exception\n");
	    	break;
	    case 5:
	    	uart_puts("New Machine Error Exception\n");
	    	 break;
	    case 6:
	    	uart_puts("New Debug Related Exception\n");
	    	 break;
	    case 7:
	    	uart_puts("New General Exception Exception\n");
	    	 break;
	   default:
		   uart_puts("New Not Support\n");
		   	 break;
	 }
	unsigned int ipc;
	unsigned int itype;
	ipc = __nds32__mfsr(NDS32_SR_IPC);
	itype = __nds32__mfsr(NDS32_SR_ITYPE)&0xf;
	char buf[0x100];
	sprintf(buf, "New IPC:0x%p\n",ipc);
	uart_puts(buf);
	sprintf(buf,"New ITYPE:%d\n",itype);
	uart_puts(buf);
	while(1);
}
//*/


void __attribute__ ((section (".new_nds32_init"))) new_syscall_handler()
{
	static int cnt = 0;
	char buf[0x100];

	sprintf(buf, "New Syscall handler #%d\n", cnt);
	uart_puts(buf);

	if (++cnt < 5)
		asm("syscall 0x5000\n\t":::"$r0");
}

void __attribute__ ((section (".new_nds32_init"))) new_tlb_exception_handler()
{
	uart_puts("new_tlb_exception_handler\n");
}


int new_main() __attribute__ ((section (".new_nds32_init")));

int new_main()
{
	uart_puts("new main\n");


	//create a General Exception, to test error_exception_handler()
		int *pa;
		pa = 0x1;
		*pa = 3;
		printf("*pa = %d\n",*pa);
		//*/
	/* This is syscall test.
	 * You can comment it if it is not necessary. */
	/* Generate system call */
	asm("syscall 0x5000":::"$r0");

	while(1);
	return 0;
}
